/*-------------------------------------------------------------*\
 |   MIN.C   A Minimum Windows Program that displays a window. |
 |           The window can be moved, sized, minimized and     |
 |           maximized.  The WM_QUIT message is correctly      |
 |           handled so that the program terminates properly.  |
\*-------------------------------------------------------------*/

#define NOPROFILER
#define NOKANJI

#include <Windows.H>

typedef long FAR PASCAL (*FARPROC2)();

extern int __acrtused;

/*-------------------------------------------------------------*\
 |                    Function Prototypes.                     |
\*-------------------------------------------------------------*/
pragma Calling_convention (_CALLEE_POPS_STACK | _FAR_CALL | _SAVE_REGS | _WINDOWS);

far long MinWndProc (HWND, WORD, WORD, LONG);

pragma Calling_convention ();

pragma Calling_convention (_CALLEE_POPS_STACK | _SAVE_REGS);
int WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int cmdShow);
pragma Calling_convention ();

/*-------------------------------------------------------------*\
 |                 Main Function:  WinMain.                    |
\*-------------------------------------------------------------*/
int WinMain (HANDLE hInstance,   HANDLE hPrevInstance,
             LPSTR  lpszCmdLine, int    cmdShow)
    {
    HWND     hwnd;
    MSG      msg;
    WNDCLASS wndclass;

    if (__acrtused);

    if (!hPrevInstance)
        {
        wndclass.lpszClassName = (LPSTR)"MIN:MAIN";
        wndclass.hInstance     = hInstance;
        wndclass.lpfnWndProc   = (FARPROC2)MinWndProc;
        wndclass.hCursor       = LoadCursor (hInstance, (LPSTR)"hand");
        wndclass.hIcon         = LoadIcon (hInstance,(LPSTR)"snapshot");
        wndclass.lpszMenuName  = NULL;
        wndclass.hbrBackground = COLOR_WINDOW+1;
        wndclass.style         = NULL;
        wndclass.cbClsExtra    = 0;
        wndclass.cbWndExtra    = 0;

        RegisterClass( (LPWNDCLASS)&wndclass);
        }

    hwnd = CreateWindow((LPSTR)"MIN:MAIN",    /* Class name.   */
                        (LPSTR)"Minimum",     /* Title.        */
                        WS_OVERLAPPEDWINDOW,  /* Style bits.   */
                        CW_USEDEFAULT,        /* x - default.  */
                        0,                    /* y - default.  */
                        CW_USEDEFAULT,        /* cx - default. */
                        0,                    /* cy - default. */
                        NULL,                 /* No parent.    */
                        NULL,                 /* Class menu.   */
                        hInstance,            /* Creator.      */
                        NULL);                /* Params.       */

    ShowWindow (hwnd, cmdShow);

    while (GetMessage((LPMSG)&msg, 0, 0, 0))
        {
        TranslateMessage((LPMSG)&msg); /*  Keyboard input.     */
        DispatchMessage((LPMSG)&msg);
        }
    return 0;
    }

/*-------------------------------------------------------------*\
 |              Window Procedure:  MinWndProc.                 |
\*-------------------------------------------------------------*/
far long MinWndProc (HWND hwnd,   WORD wMsg,
                     WORD wParam, LONG lParam)
    {
    switch (wMsg)
        {
        case WM_DESTROY:
            PostQuitMessage(0);
            break;

        default:
            return(DefWindowProc(hwnd,wMsg,wParam,lParam));
        }
    return 0L;
    }
